/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007,2011,2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
 *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
 *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
 *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
 *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
 *      スコード中に含まれていること．
 *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
 *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
 *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
 *      の無保証規定を掲載すること．
 *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
 *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
 *      と．
 *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
 *        作権表示，この利用条件および下記の無保証規定を掲載すること．
 *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
 *        報告すること．
 *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
 *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
 *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
 *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
 *      免責すること．
 *
 *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
 *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
 *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
 *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
 *  の責任を負わない．
 *
 */

#ifndef TOPPERS_LPC5500_H
#define TOPPERS_LPC5500_H

#define LPC5500_SYSCON_BASE 0x50000000
#define LPC5500_SYSCON_AHBCLKCTRLSET0 ((uint32_t *)(LPC5500_SYSCON_BASE + 0x220))
#define LPC5500_SYSCON_AHBCLKCTRLSET1 ((uint32_t *)(LPC5500_SYSCON_BASE + 0x224))
#define LPC5500_SYSCON_AHBCLKCTRLSET2 ((uint32_t *)(LPC5500_SYSCON_BASE + 0x228))
#define LPC5500_SYSCON_AHBCLKCTRLCLR0 ((uint32_t *)(LPC5500_SYSCON_BASE + 0x240))
#define LPC5500_SYSCON_AHBCLKCTRLCLR1 ((uint32_t *)(LPC5500_SYSCON_BASE + 0x244))
#define LPC5500_SYSCON_AHBCLKCTRLCLR2 ((uint32_t *)(LPC5500_SYSCON_BASE + 0x248))
#define LPC5500_SYSCON_CTIMERCLKSEL0  ((uint32_t *)(LPC5500_SYSCON_BASE + 0x26C))
#define LPC5500_SYSCON_CTIMERCLKSEL1  ((uint32_t *)(LPC5500_SYSCON_BASE + 0x270))
#define LPC5500_SYSCON_CTIMERCLKSEL2  ((uint32_t *)(LPC5500_SYSCON_BASE + 0x274))
#define LPC5500_SYSCON_CTIMERCLKSEL3  ((uint32_t *)(LPC5500_SYSCON_BASE + 0x278))
#define LPC5500_SYSCON_CTIMERCLKSEL4  ((uint32_t *)(LPC5500_SYSCON_BASE + 0x27C))
#define LPC5500_SYSCON_MAINCLKSELA    ((uint32_t *)(LPC5500_SYSCON_BASE + 0x280))
#define LPC5500_SYSCON_MAINCLKSELB    ((uint32_t *)(LPC5500_SYSCON_BASE + 0x284))
#define LPC5500_SYSCON_PLL0CLKSEL     ((uint32_t *)(LPC5500_SYSCON_BASE + 0x290))
#define LPC5500_SYSCON_PLL1CLKSEL     ((uint32_t *)(LPC5500_SYSCON_BASE + 0x294))
#define LPC5500_SYSCON_FCCLKSEL0      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x2B0))
#define LPC5500_SYSCON_FCCLKSEL1      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x2B4))
#define LPC5500_SYSCON_FCCLKSEL2      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x2B8))
#define LPC5500_SYSCON_FCCLKSEL3      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x2BC))
#define LPC5500_SYSCON_FCCLKSEL4      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x2C0))
#define LPC5500_SYSCON_FCCLKSEL5      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x2C4))
#define LPC5500_SYSCON_FCCLKSEL6      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x2C8))
#define LPC5500_SYSCON_FCCLKSEL7      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x2CC))
#define LPC5500_SYSCON_FCCLKSEL(n)    ((uint32_t *)(LPC5500_SYSCON_FCCLKSEL0 + ((n) * 4)))
#define LPC5500_SYSCON_FLEXFRG0CTRL   ((uint32_t *)(LPC5500_SYSCON_BASE + 0x320))
#define LPC5500_SYSCON_FLEXFRG1CTRL   ((uint32_t *)(LPC5500_SYSCON_BASE + 0x324))
#define LPC5500_SYSCON_FLEXFRG2CTRL   ((uint32_t *)(LPC5500_SYSCON_BASE + 0x328))
#define LPC5500_SYSCON_FLEXFRG3CTRL   ((uint32_t *)(LPC5500_SYSCON_BASE + 0x32C))
#define LPC5500_SYSCON_FLEXFRG4CTRL   ((uint32_t *)(LPC5500_SYSCON_BASE + 0x330))
#define LPC5500_SYSCON_FLEXFRG5CTRL   ((uint32_t *)(LPC5500_SYSCON_BASE + 0x334))
#define LPC5500_SYSCON_FLEXFRG6CTRL   ((uint32_t *)(LPC5500_SYSCON_BASE + 0x338))
#define LPC5500_SYSCON_FLEXFRG7CTRL   ((uint32_t *)(LPC5500_SYSCON_BASE + 0x33C))
#define LPC5500_SYSCON_AHBCLKDIV      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x380))
#define LPC5500_SYSCON_PLL0CLKDIV     ((uint32_t *)(LPC5500_SYSCON_BASE + 0x3C4))
#define LPC5500_SYSCON_FMCCR          ((uint32_t *)(LPC5500_SYSCON_BASE + 0x400))
#define LPC5500_SYSCON_PLL0CTRL       ((uint32_t *)(LPC5500_SYSCON_BASE + 0x580))
#define LPC5500_SYSCON_PLL0STAT       ((uint32_t *)(LPC5500_SYSCON_BASE + 0x584))
#define LPC5500_SYSCON_PLL0NDEC       ((uint32_t *)(LPC5500_SYSCON_BASE + 0x588))
#define LPC5500_SYSCON_PLL0PDEC       ((uint32_t *)(LPC5500_SYSCON_BASE + 0x58C))
#define LPC5500_SYSCON_PLL0SSCG0      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x590))
#define LPC5500_SYSCON_PLL0SSCG1      ((uint32_t *)(LPC5500_SYSCON_BASE + 0x594))
#define LPC5500_SYSCON_CPUCTRL        ((uint32_t *)(LPC5500_SYSCON_BASE + 0x800))
#define LPC5500_SYSCON_CPBOOT         ((uint32_t *)(LPC5500_SYSCON_BASE + 0x804))
#define LPC5500_SYSCON_CLOCK_CTRL     ((uint32_t *)(LPC5500_SYSCON_BASE + 0xA18))

#define LPC5500_SYSCON_AHBCLKCTRL0_IOCON           (1 << 13)
#define LPC5500_SYSCON_AHBCLKCTRL0_MAILBOX         (1 << 26)
#define LPC5500_SYSCON_AHBCLKCTRL1_FC0             (1 << 11)
#define LPC5500_SYSCON_AHBCLKCTRL1_FC1             (1 << 12)
#define LPC5500_SYSCON_AHBCLKCTRL1_FC2             (1 << 13)
#define LPC5500_SYSCON_AHBCLKCTRL1_FC3             (1 << 14)
#define LPC5500_SYSCON_AHBCLKCTRL1_FC4             (1 << 15)
#define LPC5500_SYSCON_AHBCLKCTRL1_FC5             (1 << 16)
#define LPC5500_SYSCON_AHBCLKCTRL1_FC6             (1 << 17)
#define LPC5500_SYSCON_AHBCLKCTRL1_FC7             (1 << 18)
#define LPC5500_SYSCON_AHBCLKCTRL1_FC(n)           (1 << (11 + (n)))
#define LPC5500_SYSCON_AHBCLKCTRL1_TIMER2          (1 << 22)
#define LPC5500_SYSCON_AHBCLKCTRL1_TIMER0          (1 << 26)
#define LPC5500_SYSCON_AHBCLKCTRL1_TIMER1          (1 << 27)
#define LPC5500_SYSCON_MAINCLKSELB_SEL_PLL0        1
#define LPC5500_SYSCON_PLL0CLKSEL_SEL_CLKIN        1
#define LPC5500_SYSCON_CTIMERCLKSEL_SEL_MAIN_CLOCK 0
#define LPC5500_SYSCON_FCCLKSEL_SEL_PLL0DIV        1
#define LPC5500_SYSCON_FLEXFRGCTRL_DIV(v)          ((v) << 0)
#define LPC5500_SYSCON_FLEXFRGCTRL_MULT(v)         ((v) << 8)
#define LPC5500_SYSCON_AHBCLKDIV_DIV(n)            (n)
#define LPC5500_SYSCON_FMCCR_FLASHTIM(n)           ((n) << 12)
#define LPC5500_SYSCON_FMCCR_FLASHTIM_MASK         (0b11111 << 12)
#define LPC5500_SYSCON_PLL0NDEC_NDIV(n)            (n)
#define LPC5500_SYSCON_PLL0NDEC_NREQ               (1 << 8)
#define LPC5500_SYSCON_PLL0SSCG1_MDIV_EXT(m)       ((m) << 10)
#define LPC5500_SYSCON_PLL0SSCG1_MREQ              (1 << 26)
#define LPC5500_SYSCON_PLL0SSCG1_SEL_EXT           (1 << 28)
#define LPC5500_SYSCON_PLL0PDEC_PDIV(p)            (p)
#define LPC5500_SYSCON_PLL0PDEC_PREQ               (1 << 5)
#define LPC5500_SYSCON_PLL0CTRL_SELR(r)            (r)
#define LPC5500_SYSCON_PLL0CTRL_SELI(i)            ((i) << 4)
#define LPC5500_SYSCON_PLL0CTRL_SELP(p)            ((p) << 10)
#define LPC5500_SYSCON_PLL0CTRL_BYPASSPOSTDIV2     (1 << 16)
#define LPC5500_SYSCON_PLL0CTRL_CLKEN              (1 << 21)
#define LPC5500_SYSCON_PLL0STAT_LOCK               (1 << 0)
#define LPC5500_SYSCON_CPUCTRL_CPU1CLKEN           (1 << 3)
#define LPC5500_SYSCON_CPUCTRL_MAGIC               (0xC0C4 << 16)
#define LPC5500_SYSCON_CLOCK_CTRL_CLKIN_ENA        (1 << 5)

#define LPC5500_FLASH_BASE 0x40034000
#define LPC5500_FLASH_CMD            ((uint32_t *)(LPC5500_FLASH_BASE + 0x0))
#define LPC5500_FLASH_DATAW(n)       ((uint32_t *)(LPC5500_FLASH_BASE + 0x80 * (n)))
#define LPC5500_FLASH_INT_STATUS     ((uint32_t *)(LPC5500_FLASH_BASE + 0xFE0))
#define LPC5500_FLASH_INT_CLR_STATUS ((uint32_t *)(LPC5500_FLASH_BASE + 0xFE8))

#define LPC5500_FLASH_CMD_SET_READ_MODE 2
#define LPC5500_FLASH_INT_STATUS_ALL    0x7
#define LPC5500_FLASH_INT_STATUS_DONE   (1 << 2)

#define LPC5500_ANACTRL_BASE 0x50013000
#define LPC5500_ANACTRL_XO32M_CTRL   ((uint32_t *)(LPC5500_ANACTRL_BASE + 0x20))
#define LPC5500_ANACTRL_XO32M_STATUS ((uint32_t *)(LPC5500_ANACTRL_BASE + 0x20))

#define LPC5500_ANACTRL_XO32M_CTRL_ENABLE_SYSTEM_CLK_OUT (1 << 24)
#define LPC5500_ANACTRL_XO32M_STATUS_XO_READY            (1 << 0)

#define LPC5500_PMC_BASE         0x40020000
#define LPC5500_PMC_PDRUNCFGCLR0 ((uint32_t *)(LPC5500_PMC_BASE + 0xC8))

#define LPC5500_PMC_PDRUNCFG0_PDEN_XTAL32M  (1 << 8)
#define LPC5500_PMC_PDRUNCFG0_PDEN_PLL0     (1 << 9)
#define LPC5500_PMC_PDRUNCFG0_PDEN_LDOXO32M (1 << 20)

#define LPC5500_IOCON_BASE 0x40001000
#define LPC5500_IOCON_P0(n) ((uint32_t *)(LPC5500_IOCON_BASE + ((n) * 4)))
#define LPC5500_IOCON_P1(n) ((uint32_t *)(LPC5500_IOCON_BASE + 0x080 + ((n) * 4)))

#define LPC5500_IOCON_P_FUNC(n)  (n)
#define LPC5500_IOCON_P_DIGIMODE (1 << 8)

#define LPC5500_CTIMER0_BASE 0x40008000
#define LPC5500_CTIMER1_BASE 0x40009000
#define LPC5500_CTIMER2_BASE 0x40028000
#define LPC5500_CTIMER3_BASE 0x40029000
#define LPC5500_CTIMER4_BASE 0x4002A000

#define LPC5500_CTIMER_IR(base)  ((uint32_t *)((base) + 0x00))
#define LPC5500_CTIMER_TCR(base) ((uint32_t *)((base) + 0x04))
#define LPC5500_CTIMER_TC(base)  ((uint32_t *)((base) + 0x08))
#define LPC5500_CTIMER_PR(base)  ((uint32_t *)((base) + 0x0C))
#define LPC5500_CTIMER_MCR(base) ((uint32_t *)((base) + 0x14))
#define LPC5500_CTIMER_MR0(base) ((uint32_t *)((base) + 0x18))

#define LPC5500_CTIMER_IR_MR0INT (1 << 0)
#define LPC5500_CTIMER_TCR_CEN   (1 << 0)
#define LPC5500_CTIMER_TCR_CRST  (1 << 1)
#define LPC5500_CTIMER_MCR_MR0I  (1 << 0)
#define LPC5500_CTIMER_MCR_MR0R  (1 << 1)
#define LPC5500_CTIMER_MCR_MR0S  (1 << 2)

#define LPC5500_CTIMER0_IRQn 10
#define LPC5500_CTIMER1_IRQn 11

#define LPC5500_FLEXCOMM0_BASE 0x40086000
#define LPC5500_FLEXCOMM1_BASE 0x40087000
#define LPC5500_FLEXCOMM2_BASE 0x40088000
#define LPC5500_FLEXCOMM3_BASE 0x40089000
#define LPC5500_FLEXCOMM4_BASE 0x4008A000
#define LPC5500_FLEXCOMM5_BASE 0x40096000
#define LPC5500_FLEXCOMM6_BASE 0x40097000
#define LPC5500_FLEXCOMM7_BASE 0x40098000

#define LPC5500_FLEXCOMM_PSELID(base) ((uint32_t *)((base) + 0xFF8))

#define LPC5500_FLEXCOMM_PSELID_PERSEL_USART 0x1

#define LPC5500_FLEXCOMM0_IRQn 14
#define LPC5500_FLEXCOMM1_IRQn 15
#define LPC5500_FLEXCOMM2_IRQn 16
#define LPC5500_FLEXCOMM3_IRQn 17
#define LPC5500_FLEXCOMM4_IRQn 18
#define LPC5500_FLEXCOMM5_IRQn 19
#define LPC5500_FLEXCOMM6_IRQn 20
#define LPC5500_FLEXCOMM7_IRQn 21

#define LPC5500_USART0_BASE 0x40086000
#define LPC5500_USART1_BASE 0x40087000
#define LPC5500_USART2_BASE 0x40088000
#define LPC5500_USART3_BASE 0x40089000
#define LPC5500_USART4_BASE 0x4008A000
#define LPC5500_USART5_BASE 0x40096000
#define LPC5500_USART6_BASE 0x40097000
#define LPC5500_USART7_BASE 0x40098000

#define LPC5500_USART_CFG(base)          ((uint32_t *)((base) + 0x000))
#define LPC5500_USART_CRL(base)          ((uint32_t *)((base) + 0x004))
#define LPC5500_USART_INTENSET(base)     ((uint32_t *)((base) + 0x00C))
#define LPC5500_USART_BRG(base)          ((uint32_t *)((base) + 0x020))
#define LPC5500_USART_FIFOCFG(base)      ((uint32_t *)((base) + 0xE00))
#define LPC5500_USART_FIFOSTAT(base)     ((uint32_t *)((base) + 0xE04))
#define LPC5500_USART_FIFOTRIG(base)     ((uint32_t *)((base) + 0xE08))
#define LPC5500_USART_FIFOINTENSET(base) ((uint32_t *)((base) + 0xE10))
#define LPC5500_USART_FIFOINTENCLR(base) ((uint32_t *)((base) + 0xE14))
#define LPC5500_USART_FIFOINTSTAT(base)  ((uint32_t *)((base) + 0xE18))
#define LPC5500_USART_FIFOWR(base)       ((uint32_t *)((base) + 0xE20))
#define LPC5500_USART_FIFORD(base)       ((uint32_t *)((base) + 0xE30))

#define LPC5500_USART_CFG_ENABLE          (1 << 0)
#define LPC5500_USART_CFG_DATALEN_8BIT    (0x1 << 2)
#define LPC5500_USART_FIFOCFG_ENABLETX    (1 << 0)
#define LPC5500_USART_FIFOCFG_ENABLERX    (1 << 1)
#define LPC5500_USART_FIFOSTAT_TXNOTFULL  (1 << 5)
#define LPC5500_USART_FIFOSTAT_RXNOTEMPTY (1 << 6)
#define LPC5500_USART_FIFOTRIG_TXLVLENA   (1 << 0)
#define LPC5500_USART_FIFOTRIG_RXLVLENA   (1 << 1)
#define LPC5500_USART_FIFOTRIG_TXLVL(v)   ((v) << 8)
#define LPC5500_USART_FIFOTRIG_RXLVL(v)   ((v) << 16)
#define LPC5500_USART_FIFOINTEN_TXLVL     (1 << 2)
#define LPC5500_USART_FIFOINTEN_RXLVL     (1 << 3)
#define LPC5500_USART_FIFOINTSTAT_TXLVL   (1 << 2)
#define LPC5500_USART_FIFOINTSTAT_RXLVL   (1 << 3)

#define LPC5500_MAILBOX_BASE    0x5008B000
#define LPC5500_MAILBOX_IRQ0    ((uint32_t *)(LPC5500_MAILBOX_BASE + 0x000))
#define LPC5500_MAILBOX_IRQ0SET ((uint32_t *)(LPC5500_MAILBOX_BASE + 0x004))
#define LPC5500_MAILBOX_IRQ0CLR ((uint32_t *)(LPC5500_MAILBOX_BASE + 0x008))
#define LPC5500_MAILBOX_IRQ1    ((uint32_t *)(LPC5500_MAILBOX_BASE + 0x010))
#define LPC5500_MAILBOX_IRQ1SET ((uint32_t *)(LPC5500_MAILBOX_BASE + 0x014))
#define LPC5500_MAILBOX_IRQ1CLR ((uint32_t *)(LPC5500_MAILBOX_BASE + 0x018))
#define LPC5500_MAILBOX_MUTEX   ((uint32_t *)(LPC5500_MAILBOX_BASE + 0x0F8))

#define LPC5500_MAILBOX_IRQn 31

#endif
